<template>
  <!-- v-appで囲まないとvuetifyの機能が上手く動作しない-->
  <v-app>
    <!-- 検索欄を別コンポーネントで用意して呼び出し -->
    <GridSearch></GridSearch>
    <div>
      <v-data-table
        v-model="selected"
        :headers="headers"
        :items="poGrid"
        :items-per-page="5"
        :single-select="singleSelect"
        group-by="po"
        show-select
        class="elevation-1"
        @click:row="clickRow"
      >
      </v-data-table>
      <v-divider></v-divider>
      <ui>
        <!-- 詳細欄についてはリストで実装し、条件を満たしたもののみ表示-->
        <!-- v-showを使うとDOM自体は削除しないため、入力した値が保持される-->
        <div v-for="(detail, index) in detailDatas" :key="detail">
          <transition name="fade">
            <div v-show="detailShow == true && index == selectedRow">
              <div class="row">
                <div class="col-sm-12">
                  <h2>詳細</h2>
                </div>
                <div class="col-sm-5">
                  <p>選択した行番号</p>
                  <p>{{ index }}</p>
                </div>
                <div class="col-sm-5">
                  <p>オーダ番号</p>
                  <p>{{ detail.po }}</p>
                </div>
                <div class="col-sm-5">
                  <p>受入済数</p>
                  <p>{{ detail.qty_recieve }}</p>
                </div>
                <v-form>
                  <div class="col-sm-12">
                    <label>数量</label>
                    <textbox-tenkey></textbox-tenkey>
                  </div>
                </v-form>
              </div>
            </div>
          </transition>
        </div>
      </ui>
    </div>
  </v-app>
</template>

<script>
import Vue from "vue";
import { BootstrapVue, IconsPlugin } from "bootstrap-vue";
import "bootstrap/dist/css/bootstrap.css";
import "bootstrap-vue/dist/bootstrap-vue.css";
import textboxTenkey from "../textbox/textbox-tenkey";
import gridSearch from "./gridSearch";

Vue.use(BootstrapVue);
Vue.use(IconsPlugin);
export default {
  components: {
    TextboxTenkey: textboxTenkey,
    GridSearch: gridSearch,
  },
  data() {
    return {
      singleSelect: false,
      detailShow: false,
      selectedRow: 0,
      selected: [],

      // 直書きしているグリッド用のデータをAPI通信によってJSON形式で受け取ればよい  
      // データについては当ファイルの親コンポーネントを用意してそちらでやり取りする方がよい
      detailDatas: [
        {
          po: "P0000001",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
          qty_recieve: 20,
        },
        {
          po: "P0000001",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
          qty_recieve: 40,
        },
        {
          po: "P0000001",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
          qty_recieve: 50,
        },
        {
          po: "P0000002",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
          qty_recieve: 80,
        },
        {
          po: "P0000002",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
          qty_recieve: 90,
        },
        {
          po: "P0000002",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
          qty_recieve: 10,
        },
        {
          po: "P0000003",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
          qty_recieve: 60,
        },
      ],
      headers: [
        { text: "オーダ番号", value: "po" },
        {
          text: "明細",
          align: "start",
          sortable: false,
          value: "po_line",
        },
        { text: "発行", align: "right", value: "po_release" },
        { text: "品目", value: "item" },
        { text: "品名", value: "description" },
        { text: "発注数", value: "qty_ordered" },
        { text: "受入済数", value: "qty_received" },
        { text: "不良数", value: "qty_rejected" },
        { text: "状況", value: "stat" },
        { text: "納期", value: "due_date" },
        { text: "最新受入日", value: "rcvd_date" },
      ],
      poGrid: [
        {
          po: "P0000001",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
        },
        {
          po: "P0000001",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
        },
        {
          po: "P0000001",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
        },
        {
          po: "P0000002",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
        },
        {
          po: "P0000002",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
        },
        {
          po: "P0000002",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
        },
        {
          po: "P0000003",
          po_line: 1,
          po_release: 1,
          item: "CP-2000",
          description: "Seat,Padded",
          qty_ordered: 20,
          qty_received: 0,
          qty_rejected: 0,
          stat: "発注",
          due_date: "2021/07/01",
          rcvd_date: "2021/07/20",
        },
      ],
    };
  },

  methods: {
    getColor(calories) {
      if (calories > 400) return "red";
      else if (calories > 200) return "orange";
      else return "green";
    },
    clickRow: function(record) {
      // 引数のrecordには選択した行のオブジェクトが入っている
      // alertのコメントアウトを外すとデータのイメージが付くはず

      // 対応する詳細画面を表示させる
      this.selectedRow = this.poGrid.indexOf(record);
      this.detailShow = true;
    },
  },
};
</script>
<style>
/* Transition用のスタイル*/
.fade-enter,
.fade-leave-to {
  opacity: 0;
}

.fade-enter-to,
.fade-leave {
  opacity: 0;
}

.fade-enter-active {
  transition: opacity 150ms ease-out;
}
.fade-leave-active {
  transition: opacity 0s;
}
/*v-btnのスタイル上書き作動しなくなったためimportantで対応*/

.v-btn {
  display: none !important;
}
</style>
